import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.AffineTransform;


/**
 * Ein Sessel, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version 2.2  (aug 07)
 */
public class Sessel extends Moebel
{

    /**
     * Erzeuge einen neuen Sessel mit einer Standardfarbe und Standardgroesse
     * an einer Standardposition. (Standardkonstruktor)
     */
    public Sessel() {
        xPosition = 160;
        yPosition = 80;
        farbe = "blau";
        orientierung = 0;
        istSichtbar = false;
        breite = 40;
        tiefe  = 40;
    }
    
    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
     */
    protected Shape gibAktuelleFigur() {
        // einen GeneralPath definieren
        GeneralPath sessel = new GeneralPath();
        Rectangle2D linkeSesselLehne = new Rectangle2D.Double(0,0,10,60);
        Rectangle2D rechteSesselLehne = new Rectangle2D.Double(50,0,10,60);
        Rectangle2D sitzFlaeche = new Rectangle2D.Double(10,10,40,50);
        Rectangle2D ruecken = new Rectangle2D.Double(10,0,40,10);
        sessel.append(linkeSesselLehne,false);
        sessel.append(rechteSesselLehne,false);
        sessel.append(sitzFlaeche,false);
        sessel.append(ruecken,false);
        
        // transformieren:
        AffineTransform t = new AffineTransform();
        t.translate(xPosition, yPosition);
        t.rotate(Math.toRadians(orientierung),breite/2,tiefe/2);
        return  t.createTransformedShape(sessel);
    }
    
}
